routes/web.php
<?php

use App\Http\Controllers\PostController;
use App\Http\Controllers\AccauntController;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider and all of them will
| be assigned to the "web" middleware group. Make something great!
|
*/

Route::get('/', [PostController::class , 'index'])->middleware('auth')->name('home');

Route::resource('posts', PostController::class)->middleware('auth')->except('create');
Route::get('posts/{user}/create', [PostController::class, 'create'])->middleware('auth')->name('posts.create');
Route::resource('account', AccauntController::class)->middleware('auth');
Route::resource('posts.comments', \App\Http\Controllers\PostsCommentsController::class)->middleware('auth');
Route::resource('posts.likes', \App\Http\Controllers\PostsLikesContoller::class)->middleware('auth');
Route::resource('account.following', \App\Http\Controllers\AccauntsFollowingController::class)->middleware('auth');

Auth::routes();

app/Models/Post.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Post extends Model
{
    use HasFactory;

    protected $withCount = ['liked'];

    protected $fillable =
        ['user_id', 'image', 'description'];

    public function user()
    {
        return $this->belongsTo(User::class);
    }

    public function comments()
    {
        return $this->hasMany(Comment::class);
    }

    public function liked()
    {
        return $this->belongsToMany(User::class, 'post_user_likes', 'post_id', 'user_id');
    }
}

app/Http/Controllers/PostController.php
<?php

namespace App\Http\Controllers;

use App\Models\Comment;
use App\Models\Post;
use App\Models\User;
use Dflydev\DotAccessData\Data;
use Illuminate\Http\Request;

class PostController extends Controller
{
    /**
     * @return \Illuminate\Contracts\Foundation\Application|\Illuminate\Contracts\View\Factory|\Illuminate\Contracts\View\View|\Illuminate\Foundation\Application
     */
    public function index()
    {

        $posts = Post::all();
        return view('posts.index', compact('posts'));

    }

    /**
     * @param Post $post
     * @return \Illuminate\Contracts\Foundation\Application|\Illuminate\Contracts\View\Factory|\Illuminate\Contracts\View\View|\Illuminate\Foundation\Application
     */
    public function show(Post $post)
    {


        $comments = Post::find($post->id)->comments->where('approve', '1');

        return view('posts.show', compact('post','comments'));
    }
    public function store(Request $request)
    {
      $validated = $request->validate([
              'image' => 'required|image',
              'description' => 'required|min:2|max:2048',
                'user_id' => 'required|min:1|max:255|int'
          ]);
        $picture = data_get($validated, 'image');
        if ($picture) {
            $path = $picture->store('image', 'public');
            $validated['image'] = $path;
        }
     $account = $validated['user_id'] ;
        Post::create($validated);
        return redirect()->route('account.show', compact('account'))->with('status', 'фото добавлено');

    }

    public function create(User $user)
    {
        $this->authorize('create-post', $user);
//        $user = $request->user;
        return view('accounts.create', compact('user'));
    }
}

resources/views/posts/index.blade.php
@extends('layouts.app')

@section('content')

@foreach($posts as $post)
<div class="Instagram-card">
    <div class="Instagram-card-header">
        @if($post->user->avatar)
        <img src="{{asset('/storage/'.$post->user->avatar) }}" class="Instagram-card-user-image">
        @else
            <img src="{{asset('default.jpg') }}" class="Instagram-card-user-image">
            @endif
            <a class="Instagram-card-user-name" href="{{route('account.show', ['account'=> $post->user->id])}}"> {{ $post->user->name }}</a>
        <div class="Instagram-card-time"> 1 sem </div>
    </div>

    <div class="Instagram-card-image p-5">
        <a href="{{route('posts.show', ['post'=> $post])}}">
            <img src= "{{asset('/storage/'.$post->image) }}"  height=500px/>
        </a>
    </div>

    <div class="Instagram-card-content">
        <form action="{{route('posts.likes.store', ['post' =>$post])}}" method="post">
            @csrf
            <button type="submit" class="border-0 bg-transparent">
                @auth()
                    <span>{{$post->liked_count}}</span>
                @if(auth()->user()->likedPosts->contains($post->id))
                        <img style="width: 33px; height: 33px"
                             src="{{asset('img/like.png')}}"
                             alt="">
                    @else
                        <img style="width: 33px; height: 33px"
                             src="{{asset('img/2.jpg')}}"
                             alt="">
                    @endif

                @endauth
            </button>
        </form>

        <p><a class="Instagram-card-content-user"
                href="{{route('account.show', ['account'=> $post->user->id])}}">{{ $post->user->name }}</a>
            {{$post->description}}</p>

    </div>
    <hr>

</div>
@endforeach
@endsection

resources/views/posts/show.blade.php
@extends('layouts.app')

@section('content')
    @include('notifications.alerts')

    <div class="Instagram-card">
    <div class="Instagram-card-header">
        <img src="{{asset('/storage/'.$post->user->avatar) }}" class="Instagram-card-user-image">
        <a class="Instagram-card-user-name" href="{{route('account.show', ['account'=> $post->user->id])}}"> {{ $post->user->name }}</a>
        <div class="Instagram-card-time"> <a href="{{route('account.show', ['account'=> $post->user])}}" class="fs-2">x</a> </div>
    </div>

    <div class="Instagram-card-image p-5">
        <img src= "{{asset('/storage/'.$post->image) }}"  height=500px/>
    </div>

    <div class="Instagram-card-content">
        <form action="{{route('posts.likes.store', ['post' =>$post])}}" method="post">
            @csrf
            <button type="submit" class="border-0 bg-transparent">
                <span>{{$post->liked_count}}</span>
            @auth()
                    @if(auth()->user()->likedPosts->contains($post->id))
                        <img style="width: 33px; height: 33px"
                             src="{{asset('img/like.png')}}"
                             alt="">
                    @else
                        <img style="width: 33px; height: 33px"
                             src="{{asset('img/2.jpg')}}"
                             alt="">
                    @endif

                @endauth
            </button>
        </form>
        <p><a class="Instagram-card-content-user"
              href="{{route('account.show', ['account'=> $post->user->id])}}">{{ $post->user->name }}</a>
            {{$post->description}}</p>


        <p class="comments">Комментарии</p>
    @foreach($comments as $comment)
        <br><a class="user-comment" href="">{{$comment->user_id}}</a> {{$comment->comment}}</br>
        @can('delete-comment', $comment)
            <form action="{{route('posts.comments.destroy', ['post'=> $post ,'comment'=>$comment])}} " method="POST" >
                @csrf
                @method('DELETE')
                <button type="submit"> delete</button>
            </form>
            @endcan
        <hr>
        @endforeach

    </div>

    <div class="Instagram-card-footer">
        <a class="footer-action-icons"href="#"><i class="fa fa-heart-o"></i></a>
        <form action="{{route('posts.comments.store', ['post' => $post])}}" method="post">
            @csrf
            <input name="comment" class="comments-input" type="text" placeholder="Добавить комментарии..."/>
            <input type="hidden" name="user_id" value="{{auth()->user()->id}}">
            <input type="hidden" name="post_user_id" value="{{$post->user_id}}">

            <button type="submit">добавить</button>

        </form>

        <a class="footer-action-icons"href="#"><i class="fa fa-ellipsis-h"></i></a>
    </div>

</div>
@endsection